Include auth_source field in User API response
2016-07-12 15:37 - Roger Martensson
Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: REST API Estimated time: 0.00 hour
Target version: 6.0.0

Resolution: Fixed

Description

it would've been nice to be able to get which auth_source_id a given user has through the REST API. A nice complement to when
creating user where it is possible to set the auth_source_id.

Related issues:
Related to Redmine - Feature #36659: Add "auth_source_id" to GET request for ... Closed

Related to Redmine - Feature #23306: Support for authentication sources in RE... New

Associated revisions

Revision 22636 - 2024-01-25 17:13 - Marius BALTEANU

Include auth_source in /users/:id API response if auth_source is requested (include=auth_source) and request is made by an administrator (#23307).

Patch by Go MAEDA (@maeda) and Marius BALTEANU (@marius.balteanu).

Revision 22666 - 2024-01-31 04:24 - Marius BALTEANU

Include auth_source in /users API response if request includes auth_source (#23307).

Revision 22668 - 2024-02-01 12:45 - Go MAEDA
Fix RuboCop offense Layout/SpaceAroundBlockParameters (#23307).

History

#1 - 2016-08-09 17:38 - Toshi MARUYAMA
- Related to Feature #23306: Support for authentication sources in REST API added

#2 - 2018-02-06 18:01 - Anonymous

- File add_auth_source_id_to_api.patch added

| agree. This feature is also useful for admin scripts which needs to distinguish between "external" and LDAP users.

| attached a patch for this feature. auth_source_id only gets visible for admin users in it, as | do not see the need for standard users.

#3 - 2018-02-08 10:17 - Anonymous

toshio harita MARUYAMA : Do you have an opinion on this issue?

#4 - 2018-09-27 15:26 - Roger Martensson

What is the status of this issue?

#5 - 2018-09-27 15:35 - Go MAEDA

- Target version set to Candidate for next major release

#6 - 2019-09-07 02:47 - Go MAEDA
| think the response should include not only id but also name. Maybe the response does not include "auth_source" if the user uses internal
authentication.

{
"user": {
"id": 1,
"login": "admin",

"firstname": "Redmine",
"lastname": "Admin",
"created_on": "2006-07-19T17:12:21z",
"last_login_on": "2019-09-06T06:37:53z2",
"auth_source": {

"id": 1,

"name": "LDAP test server"

#7 - 2019-09-08 05:03 - Go MAEDA
- File 0001-Add-auth_source-to-the-users-API-response.patch added

Here is a patch to add auth_source to the response of GET /users/:id.(xml|json). auth_source is included only when the users auth_source is not nil
and the current user is an administrator.

"auth_source": {
"id": 1,
"name": "LDAP test server"

o

#8 - 2022-02-20 08:25 - Go MAEDA
- Related to Feature #36659: Add "auth_source_id" to GET request for Endpoint /users. :format added

#9 - 2024-01-25 17:23 - Marius BALTEANU

- Status changed from New to Resolved

- Assignee set to Marius BALTEANU

- Target version changed from Candidate for next major release to 6.0.0

- Resolution set to Fixed

Feature added in r22636. You can now get auth_source if your request contains "include=auth_source".

#10 - 2024-01-25 17:24 - Marius BALTEANU
- Related to deleted (Feature #23306: Support for authentication sources in REST API)

#11 - 2024-01-25 17:24 - Marius BALTEANU
- Related to Feature #23306: Support for authentication sources in REST API added

#12 - 2024-01-25 17:27 - Marius BALTEANU

Should we include the auth_source also in index.api response?

#13 - 2024-01-31 04:30 - Marius BALTEANU
- Subject changed from Get which auth_source _id of a user to Add auth_source_id field to User AP/
- Assignee changed from Marius BALTEANU to Go MAEDA

I've added the field also to /user list API.

Looking again on the implementation, | think we should return "internal" if user doesn't not have an auth_source because right now there is no
difference between a request made without include=auth_source and a request with include=auth_source and user(s) with auth_source nil.

Go MAEDA, what do you think?

#14 - 2024-01-31 04:31 - Marius BALTEANU
- Subject changed from Add auth_source _id field to User API to Add auth_source field to User AP/

#15 - 2024-01-31 04:32 - Marius BALTEANU

- Subject changed from Add auth_source field to User API to Include auth_source field in User API response

#16 - 2024-01-31 05:34 - Go MAEDA
Marius BALTEANU wrote in #note-13:

Looking again on the implementation, | think we should return "internal" if user doesn't not have an auth_source because right now there is no
difference between a request made without include=auth_source and a request with include=auth_source and user(s) with auth_source nil.

You are right, | think it is better to return some value to indicate the internal authentication.

#17 - 2024-05-12 09:39 - Marius BALTEANU
- Status changed from Resolved to Closed
Go MAEDA wrote in #note-16:
Marius BALTEANU wrote in #note-13:
Looking again on the implementation, | think we should return "internal” if user doesn't not have an auth_source because right now there is

no difference between a request made without include=auth_source and a request with include=auth_source and user(s) with auth_source
nil.

You are right, | think it is better to return some value to indicate the internal authentication.

We should track this change in another ticket because we should modify also the user listing to show "Internal”.

Files
add_auth_source_id_to_api.patch 3.92 KB 2018-02-06 Anonymous
0001-Add-auth_source-to-the-users-API-response.patch 1.8 KB 2019-09-08 Go MAEDA
